<!-- ............................................................ -->
<!-- CAFEML Extension Template Module ........................... -->
<!-- file: CafeML-1.mod

     This is an extension of XHTML, a reformulation of HTML as
     a modular XML application.

     This DTD module is identified by the PUBLIC and SYSTEM identifiers:

       PUBLIC "-//W3C//ENTITIES CAFEML Extension Template 1.0//EN"
       SYSTEM "CafeML-1.mod"

     Revisions:
     (none)
     ........................................................... -->

<!-- Extension Template

     [This sample template module declares two extension element
     types, <today> and <quoteoftheday>. The parameter entity naming
     convention uses uppercase for the entity name and lowercase
     for namespace prefixes, hence this example uses 'CAFEML' and
     'cafe' respectively.]

     This module declares parameter entities used to provide
     namespace-qualified names for all CAFEML element types,
     as well as an extensible framework for attribute-based
     namespace declarations on all element types.

     The %NS.prefixed; conditional section keyword must be
     declared as "INCLUDE" in order to allow prefixing to be used.
     By default, foreign (i.e., non-XHTML) namespace modules should
     inherit %NS.prefixed; from XHTML, but this can be overridden
     when prefixing of only the non-XHTML markup is desired.

     XHTML's default value for the 'namespace prefix' is an empty
     string. The Prefix value can be redeclared either in a DTD
     driver or in a document's internal subset as appropriate.

     NOTE: As specified in [XMLNAMES], the namespace prefix serves as
     a proxy for the URI reference, and is not in itself significant.
-->

<!-- ..................................................................  -->

<!-- 1. Declare the xmlns attributes used by CAFEML dependent on whether
        CAFEML's prefixing is active. This should be used on all CAFEML
        element types as part of CAFEML's common attributes.

        If the entire DTD is namespace-prefixed, CAFEML should inherit
        %NS.decl.attrib;, otherwise it should declare %NS.decl.attrib;
        plus a default xmlns attribute on its own element types.
-->
<![%CAFEML.prefixed;[
<!ENTITY % CAFEML.xmlns.attrib
     "%NS.decl.attrib;"
>
]]>
<!ENTITY % CAFEML.xmlns.attrib
     "xmlns        %URI.datatype;           #FIXED '%CAFEML.xmlns;'"
>

<!-- now include the module's various markup declarations ........ -->

<!ENTITY % CAFEML.Common.attrib
     "%CAFEML.xmlns.attrib;
      id           ID                       #IMPLIED"
>

<!-- 2. In the attribute list for each element, declare the XML Namespace
        declarations that are legal in the document instance by including
        the %NamespaceDecl.attrib; parameter entity in the ATTLIST of
        each element type.
-->

<!ENTITY % CAFEML.today.qname  "today" >
<!ELEMENT %CAFEML.today.qname;  ( %Flow.mix; )* >
<!ATTLIST %CAFEML.today.qname;
      %CAFEML.Common.attrib;
      date CDATA #REQUIRED
>

<!ENTITY % CAFEML.quoteoftheday.qname  "quoteoftheday" >
<!ELEMENT %CAFEML.quoteoftheday.qname;  ( %blockquote.qname;, 
                                          %p.qname; ) >
<!ATTLIST %CAFEML.quoteoftheday.qname;
      %CAFEML.Common.attrib;
>

<!-- 3. If the module adds attributes to elements defined in modules that
        do not share the namespace of this module, declare those attributes
        so that they use the %CAFEML.pfx; prefix. For example:

<!ENTITY % CAFEML.img.myattr.qname "%CAFEML.pfx;myattr" >
<!ATTLIST %img.qname;
      %CAFEML.img.myattr.qname;  CDATA      #IMPLIED
>

 This would add a myattr attribute to the img element of the Image Module, 
 but the attribute's name will be the qualified name, including prefix, 
 when prefixes are selected for a document instance.
        
 We do not need to do this for this module.
     
-->

<!-- end of CafeML-1.mod -->
